clear all;

% time d3finitions
Dt = 0.01;
N = 512;
t = Dt*[0:N-1]';
M = N;

% frequency in Hz
fmax=1/(2.0*Dt); 
df=fmax/(N/2); 
f=df*[0:N/2,-N/2+1:-1]'; 
Nf=N/2+1;  % no. of non-negative fs

% angular frequency in radians/s
dw=2*pi*df; 
w=dw*[0:N/2,-N/2+1:-1]'; 
Nw=Nf;

% build a function of time
sigmat = Dt*N/50;
t0 = Dt*N/2;
y = exp( -(t-t0).^2/(2*sigmat^2) );
d = zeros(N,1);
d(1:N-1) = (y(2:N)-y(1:N-1))/Dt;

figure(1);
clf;
subplot(2,1,1);
set(gca,'LineWidth',2);
hold on;
axis( [t(1),t(end),min(d),max(d)] );
plot( t, d, 'k-', 'LineWidth', 2 );
xlabel('time (s)');
ylabel('d');

dtilde = Dt*fft(d);
asd = abs(dtilde(1:Nf));

subplot(2,1,2);
set(gca,'LineWidth',2);
hold on;
axis( [w(1),w(Nw),min(asd),max(asd)] );
plot( w(1:Nw), asd(1:Nw), 'k-', 'LineWidth', 2 );
xlabel('frequency (rad/s)');
ylabel('asd');


