D=load('days_disc_precip.txt');
t=D(:,1);
d=D(:,2);
tmax=max(t);
dmax=max(d);
Nbins = 100;
Dd = dmax/Nbins;
bins = Dd*[0:Nbins-1]';
h = hist(d,bins)';
hmax = max(h);

figure(1);
clf;
subplot(2,1,1);
set(gca,'LineWidth',2);
hold on;
axis([0 dmax 0 hmax]);
for i=[1:Nbins]
    plot( [bins(i)-Dd/2, bins(i)+Dd/2], [h(i), h(i)], 'k-', 'LineWidth', 2 );
    plot( [bins(i)-Dd/2, bins(i)-Dd/2], [0, h(i)], 'k-', 'LineWidth', 2 );
    plot( [bins(i)+Dd/2, bins(i)+Dd/2], [0, h(i)], 'k-', 'LineWidth', 2 );
end
xlabel('discharge (cfs)');
ylabel('number of days');

subplot(2,1,2);
set(gca,'LineWidth',2);
hold on;
axis([0 dmax 0 hmax]);
plot( bins, h, 'k-', 'LineWidth', 2 );
xlabel('discharge (cfs)');
ylabel('number of days');

hcum = flipud(cumsum(flipud(h)));
j = find( hcum~=0 );
hcummax = max(hcum(j));

figure(2);
clf;
set(gca,'LineWidth',2);
hold on;
axis([0 dmax -3 0]);
plot( bins(j), log10(hcum(j)/hcummax), 'ko', 'LineWidth', 2 );
xlabel('discharge (cfs)');
ylabel('log10 fraction of days exceeding discharge');





