clear all;

D = load('seismogram.txt');
[N, M] = size(D);
d = D(:,2);

dmax = max( [abs(max(d)), abs(min(d)) ]);

Nbins = 1000;
bins=2*dmax*([-Nbins/2:Nbins/2]'/((Nbins+1)/2));

h = hist(d, bins);

figure(1);
clf;
set(gca,'LineWidth',2);
hold on;
axis( [-2*dmax, 2*dmax, 0, 1.1*max(h) ] );
plot( bins, h, 'k-', 'LineWidth', 2 );
xlabel('v (um/s)');
ylabel('counts');