clear all;

N = 1000;
t = [1:N]';

k=1;
dbar = 1;
sigmad = sqrt(2*k);
n = random('Normal', 0, 1, N, 1 );
d = n.^2;

figure(1);
clf;
set(gca,'LineWidth',2);
hold on;
axis( [0, N, 0, 10] );
plot( t, d, 'k.', 'LineWidth', 2 );

figure(2);
clf;
set(gca,'LineWidth',2);
hold on;
axis( [0, N, 0, 10] );
plot( t, d, 'k.', 'LineWidth', 2 );
plot( [t(1), t(N)]' , [dbar, dbar]', 'r-', 'LineWidth', 2 );

dsort = sort(d);
f1=(1-0.682)/2;
f2 = 1-f1;
d1 = dsort(floor(f1*N));
d2 = dsort(floor(f2*N));
figure(3);
clf;
set(gca,'LineWidth',2);
hold on;
axis( [0, N, 0, 10] );
plot( t, d, 'k.', 'LineWidth', 2 );
plot( [t(1), t(N)]' , [dbar, dbar]', 'r-', 'LineWidth', 2 );
plot( [t(1), t(N)]' , [dbar-sigmad, dbar-sigmad]', 'b-', 'LineWidth', 2 );
plot( [t(1), t(N)]' , [dbar+sigmad, dbar+sigmad]', 'b-', 'LineWidth', 2 );

Nbins=30;
bins = 10*[-Nbins/2:Nbins/2]'/(Nbins/2);
h = hist( d, bins );
figure(4);
clf;
set(gca,'LineWidth',2);
hold on;
A = 400;
axis( [0, 10, 0, A] );
plot( bins, h, 'k-', 'LineWidth', 2 );
plot( [dbar, dbar]' , [0, A/10]', 'r-', 'LineWidth', 2 );
plot( [dbar-sigmad, dbar-sigmad]' , [0, A/10]', 'b-', 'LineWidth', 2 );
plot( [dbar+sigmad, dbar+sigmad]' , [0, A/10]', 'b-', 'LineWidth', 2 );

