clear all;

% Step 1: define problem
N=4;
M=2;
G = zeros(N,M);
G = [1,  1;
     1, -1;
     2,  1;
     1,  2];
 
% STEP 2: load weight data (units of kg)
D = load('weights.txt');
D
dobs = D(:,2);

% STEP 3: assign prior sqrt-variance
sigmad = 0.001; 

% STEP 4: least squares soln & covariance
mest = (G'*G)\(G'*dobs);
Cm = (sigmad^2)*inv(G'*G);

% STEP 5: confidence intervals
ci = 2*sqrt(diag(Cm));
fprintf('m1 %.6f kg +/- %.6f (95%%)\n', mest(1), ci(1) );
fprintf('m2 %.6f kg +/- %.6f (95%%)\n', mest(2), ci(2) );

dpre = G*mest;
e = dobs-dpre;
[ [1:4]', dobs, dpre, e ]

E = e'*e;
sigmadposterior = sqrt(E/(N-M));
sigmadposterior




 