clear all;

N = 100;
M = 4;
xmin = 0;
xmax = 2;
xc = 1.0;
x = xmin + (xmax-xmin)*[0:N-1]'/(N-1);
k1 = find(x<=xc);
k2 = find(x>xc);

% intercept, slope for x<xc, slope for x>xc
mtrue = [1, 1, 0, 3];
mtrue(3) = (mtrue(1)+mtrue(2)*xc)-mtrue(4)*xc+0.2;

dtrue = zeros(N,1);
dtrue(k1) = mtrue(1) + mtrue(2)*x(k1);
dtrue(k2) = mtrue(3) + mtrue(4)*x(k2);
sigmad = 0.03;
dobs = dtrue + random('Normal',0,sigmad,N,1);

figure(1);
clf;
set(gca,'LineWidth',2);
hold on;
axis( [0, 2, 0, 5] );
plot( x, dobs, 'ko', 'LineWidth', 2 );
xlabel('x');
ylabel('d');

figure(2);
clf;
set(gca,'LineWidth',2);
hold on;
axis( [0, 2, 0, 5] );
plot( x, dobs, 'ko', 'LineWidth', 2 );
xlabel('x');
ylabel('d');

G = zeros( N, M );
G(k1,1)=1;
G(k1,2)=x(k1);
G(k2,3)=1;
G(k2,4)=x(k2);

mest = (G'*G)\(G'*dobs);
dpre = G*mest;

plot( [xc, xc]', [0, 5]', 'g-', 'LineWidth', 2 );
plot( x, dpre, 'r-', 'LineWidth', 2 );

sigmah=1e-6;
H = [1, xc, -1, -xc ];
h = 0;

Cdmoh = diag((1/sigmad)*ones(N,1));
F = [(1/sigmad)*G; (1/sigmah)*H];
f = [ (1/sigmad)*dobs; (1/sigmah)*0 ];
mest2 = (F'*F)\(F'*f);
dpre2 = G*mest2;
plot( x, dpre2, 'b-', 'LineWidth', 2 );


