clear all;

G = [1,  1,  0;
     0,  1,  1;
     1,  0,  1;
     1, -1,  0;
     0,  1, -1;
    -1,  0,  1 ];

D=load('lec08_weights.txt');
dobs=D(:,2);
N=length(dobs);
M=3;

sigmadsum = 0.1;
sigmaddif = 0.01;
sigmad = [sigmadsum*ones(3,1); sigmaddif*ones(3,1)];

K=3;
H = eye(K,M);
h = 5*ones(K,1);

sigmah = 2;

F = [ diag(1./sigmad)*G; (1/sigmah)*H ];
f = [ dobs./sigmad; (1/sigmah)*h ];

mest = (F'*F)\(F'*f);

Cm = inv(F'*F);
sigmam = sqrt(diag(Cm));
ci = 2*sigmam;

fprintf('Solution\n');
for i=[1:M]
    fprintf('mtrue(%d) = %.4f +/- %.4f (95%%)\n', i, mest(i), ci(i) );
end
fprintf('\n');

dpre = G*mest;
e = dobs - dpre;
eg = e ./ sigmad;
fprintf('Data and its error\n');
fprintf('dobs\tdpre\te\teg\n');
for i=[1:N]
    fprintf('%d\t%.4f\t%.4f\t%.4f\t%.4f\n', i, dobs(i), dpre(i), e(i), eg(i) );
end
fprintf('\n');

E = eg'*eg;
Em = N-M;
sigmaE = sqrt(2*(N-M));
Elow = Em-2*sigmaE;
Ehigh=Em+2*sigmaE;
fprintf('Generalized error: %.4f\n', E );
fprintf('predicted mean error: %.4f\n', Em );
fprintf('predicted sigma error: %.4f\n', sigmaE );
fprintf('lower 95%% limit: %.4f\n', Elow );
fprintf('upper 95%% limit: %.4f\n', Ehigh );





 
