clear all;

N=101; % must be odd
Dt = 1;
t = Dt*[0:N-1]';
tmin = t(1);
tmax = t(N);
No2 = floor(N/2);

switch 4
    case 1,
        % uncorrelated random noise
        sigmad = 1;
        d = random( 'Normal', 0, sigmad, N, 1 );
    case 2,
        % sinusoid
        T = 10;
        d = cos(2*pi*t/10);
    case 3,
        % step function
        T = 10;
        d = sign(cos(2*pi*t/10));
    case 4,
        % function with cusps
        d = zeros(N,1);
        Np = 20;
        k=random('unid',N,1,Np);
        T = 2;
        for i = k;
           s = random('Normal',0,1,1,1);
           d = d + s*exp(-abs(t-t(i))/T);
        end
    otherwise,
        % zeros
        d = zeros(N,1);
end

a = xcorr(d);
Nl = No2+1;
Nr = Nl+N-1;
ta = Dt*(-No2:No2);
tamin = ta(1);
tamax = ta(N);
a = a(Nl:Nr); % puts zero lag at No2+1
[amax, iamax] = max(a);

figure(1);
clf;

subplot(2,1,1);
set(gca,'LineWidth',2);
hold on;
axis( [tmin, tmax, 1.05*min(d), 1.05*max(d)] );
plot( t, d, 'k-', 'LineWidth', 2 );
xlabel('t');
ylabel('data, d');

subplot(2,1,2);
set(gca,'LineWidth',2);
hold on;

axis( [tamin, tamax, min(a), max(a)] );
plot( ta, a, 'k-', 'LineWidth', 2 );
xlabel('t');
ylabel('autocorrelation, a');

