clear all;

N = 10000;
No2 = floor(N/2);
No4 = floor(N/4);
Dt = 1.0;
t = Dt*[0:N-1]';
tmin = t(1);
tmax = t(N);

A = 1;
N1 = 1;
N2 = floor(N1+N/5);
t1 = Dt*(N1-1);
t2 = Dt*(N2-1);
T1 = 80*Dt;
T2 = 5*Dt;
T = T1 + (T2-T1)*(t-t1)/(t2-t1);
s = 100;
f0 = A*sin(2*pi*(t-t1)./T);
f0 = f0.*(t>t1).*(t<t2).*exp(-(t-t1).^2/(2*s^2));
k = find(isnan(f0));
f0(k)=0;

sigmad=5;
% sigmad=0.5;
% sigmad=0.05;
% sigmad=0.005;
dobs = random('Normal',0,sigmad,N,1);
dtrue = zeros(N,1);
Np = 10;
for i=[1:Np]
    
    f = zeros(N,1);
    A = random('Normal',0,1,1,1);
    N1 = random('unid',N,1,1);
    N2 = floor(N1+N/5);
    t1 = Dt*(N1-1);
    t2 = Dt*(N2-1);
    T1 = 80*Dt;
    T2 = 40*Dt;
    T = T1 + (T2-T1)*(t-t1)/(t2-t1);
    s = 100;
    f = A*sin(2*pi*(t-t1)./T);
    f = f.*(t>t1).*(t<t2).*exp(-abs(t-t1)/s);
    k = find(isnan(f));
    f(k)=0;
    dtrue = dtrue + f;
    dobs = dobs + f;
end

figure(1);
clf;
subplot(4,1,1);
set(gca,'LineWidth',2);
axis( [tmin,tmax, -1, 1] );
plot( t, f0, 'k-', 'LineWidth', 2);

subplot(4,1,2);
set(gca,'LineWidth',2);
axis( [tmin,tmax, min(dobs), max(dobs)] );
plot( t, dobs, 'k-', 'LineWidth', 2);

[x,lags] = xcorr(f0,dobs);
xm = x(1:N);
Nx = length(x);

subplot(4,1,3);
set(gca,'LineWidth',2);
axis( [tmin,tmax, min(x), max(x)] );
plot( t, flipud(xm), 'k-', 'LineWidth', 2);

subplot(4,1,4);
set(gca,'LineWidth',2);
axis( [tmin,tmax, min(dtrue), max(dtrue)] );
plot( t, dtrue, 'k-', 'LineWidth', 2);


