clear all;

N = 100000;
Dt = 1;
t = Dt*[0:N-1]';
tmin = t(1);
tmax = t(end);

La = N/2-100;
Lb = N/2+100;

if( 1 )
    message1 = zeros(N,1);
    k = random('unid',N,floor(N/16),1);
    message1(k)=1;
    message1 = message1-mean(message1);
    message2 = zeros(N,1);
    k = random('unid',N,floor(N/16),1);
    message2(k)=1;
    message2 = message2-mean(message2);
else
    message1 = zeros(N,1);
    message2 = zeros(N,1);
    message1(La+50) = 1;
    message2(La+60) = 1;
    message1(La+55) = -1;
    message2(La+75) = -1;
    end

figure(1);
clf;
subplot(2,1,1);
hold on;
set(gca,'LineWidth',2);
axis( [t(La), t(Lb), 2*min(message1(La:Lb)), 2*max(message1(La:Lb)) ] );
plot( t(La:Lb), message1(La:Lb), 'k-', 'LineWidth', 2 );
subplot(2,1,2);
hold on;
set(gca,'LineWidth',2);
axis( [t(La), t(Lb), 2*min(message2(La:Lb)), 2*max(message2(La:Lb)) ] );
plot( t(La:Lb), message2(La:Lb), 'k-', 'LineWidth', 2 );

Nc = 25
0;
tc = Dt*[0:Nc-1]';
tcmin = tc(1);
tcmax = tc(end);

code1 = 2*(random('unid',2,Nc,1)-1.5);
code2 = 2*(random('unid',2,Nc,1)-1.5);
cc1 = conv( flipud(code1), code1, 'same' );
cc2 = conv( flipud(code2), code2, 'same' );

figure(2);
clf;
subplot(4,1,1);
hold on;
set(gca,'LineWidth',2);
axis( [tcmin, tcmax, 2*min(code1), 2*max(code1) ] );
plot( tc, code1, 'k-', 'LineWidth', 2 );
subplot(4,1,2);
hold on;
set(gca,'LineWidth',2);
axis( [tcmin, tcmax, 2*min(code2), 2*max(code2) ] );
plot( tc, code2, 'k-', 'LineWidth', 2 );
subplot(4,1,3);
hold on;
set(gca,'LineWidth',2);
axis( [tcmin, tcmax, 2*min(cc1), 2*max(cc1) ] );
plot( tc, cc1, 'k-', 'LineWidth', 2 );
subplot(4,1,4);
hold on;
set(gca,'LineWidth',2);
axis( [tcmin, tcmax, 2*min(cc2), 2*max(cc2) ] );
plot( tc, cc2, 'k-', 'LineWidth', 2 );

transmit1 = conv(code1, message1 );
transmit2 = conv(code2, message2 );
transmit = 0.5*(transmit1+transmit2);

figure(3);
clf;
subplot(3,1,1);
hold on;
set(gca,'LineWidth',2);
axis( [t(La), t(Lb), 2*min(transmit1(La:Lb)), 2*max(transmit1(La:Lb)) ] );
plot( t(La:Lb), transmit1(La:Lb), 'k-', 'LineWidth', 2 );
subplot(3,1,2);
hold on;
set(gca,'LineWidth',2);
axis( [t(La), t(Lb), 2*min(transmit2(La:Lb)), 2*max(transmit2(La:Lb)) ] );
plot( t(La:Lb), transmit2(La:Lb), 'k-', 'LineWidth', 2 );
subplot(3,1,3);
hold on;
set(gca,'LineWidth',2);
axis( [t(La), t(Lb), 2*min(transmit(La:Lb)), 2*max(transmit(La:Lb)) ] );
plot( t(La:Lb), transmit(La:Lb), 'k-', 'LineWidth', 2 );

receive1 = conv(flipud(code1), transmit );
receive2 = conv(flipud(code2), transmit );

% receive1 = sign(receive1);
% receive2 = sign(receive2);

j=Nc-1;
figure(4);
clf;
subplot(4,1,1);
hold on;
set(gca,'LineWidth',2);
axis( [t(La), t(Lb), 2*min(message1(La:Lb)), 2*max(message1(La:Lb)) ] );
plot( t(La:Lb), message1(La:Lb), 'k-', 'LineWidth', 2 );
subplot(4,1,2);
hold on;
set(gca,'LineWidth',2);
axis( [t(La), t(Lb), 2*min(receive1(La+j:Lb+j)), 2*max(receive1(La+j:Lb+j)) ] );
plot( t(La:Lb), receive1(La+j:Lb+j), 'r-', 'LineWidth', 2 );
subplot(4,1,3);
hold on;
set(gca,'LineWidth',2);
axis( [t(La), t(Lb), 2*min(message2(La:Lb)), 2*max(message2(La:Lb)) ] );
plot( t(La:Lb), message2(La:Lb), 'k-', 'LineWidth', 2 );
subplot(4,1,4);
hold on;
set(gca,'LineWidth',2);
axis( [t(La), t(Lb), 2*min(receive2(La+j:Lb+j)), 2*max(receive2(La+j:Lb+j)) ] );
plot( t(La:Lb), receive2(La+j:Lb+j), 'r-', 'LineWidth', 2 );

