clear all;

Nx = 201;
Ny = 51;

xmin = -2;
xmax = 2;
ymin = 0;
ymax = 2;
x = xmin + (xmax-xmin)*[0:Nx-1]'/(Nx-1);
X = zeros(Ny,Nx);
for i=[1:Nx]
for j=[1:Ny]
    X(j,i)=x(i);
end
end
y = ymin + (ymax-ymin)*[0:Ny-1]'/(Ny-1);
Y = zeros(Ny,Nx);
for i=[1:Nx]
for j=[1:Ny]
    Y(j,i)=y(j);
end
end
F = ones(Ny,Nx);

figure(1);
clf;
subplot(2,1,1);
set(gca,'LineWidth',2);
hold on;
axis xy;
axis( [xmin, xmax, ymin, ymax] );
imagesc([xmin,xmax],[ymin,ymax],abs(F));

Nq = 100;
q = pi*[0:Nq-1]'/(Nq-1);
f = ones(Nq);
xc = cos(q);
yc = sin(q);
plot( xc, yc, 'w-', 'LineWidth', 2 );
subplot(2,1,2);
set(gca,'LineWidth',2);
hold on;
axis([0, pi, 0, 5]);
plot( q, abs(f), 'k-', 'LineWidth', 2 );
subplot(2,1,1);

Npoles = 0;
Nzeros = 0;
for i=[1:100]
    str = input('pole zero undo or done ', 's' );
    if( str(1)=='p' )
        lastNpoles = Npoles;
        Npoles = Npoles+1;
        [x0,y0] = ginput(1);
        xpole(Npoles) = x0;
        ypole(Npoles) = y0;
        if( abs(y0)>0.05 )
            Npoles = Npoles+1;
            xpole(Npoles) = x0;
            ypole(Npoles) = -y0;
        else
            y0 = 0;
            ypole(Npoles) = y0;
        end
        plot( x0, y0, 'w+', 'LineWidth', 2 );
        last = 1;
    elseif( str(1)=='z' )
        lastNzeros = Nzeros;
        Nzeros = Nzeros+1;
        [x0,y0] = ginput(1);
        xzero(Nzeros) = x0;
        yzero(Nzeros) = y0;
        plot( x0, y0, 'wo', 'LineWidth', 2 );
        if( abs(y0)>0.05 )
            Nzeros = Nzeros+1;
            xzero(Nzeros) = x0;
            yzero(Nzeros) = -y0;
        else
            y0 = 0;
            yzero(Nzeros) = y0;
        end
        last = 0;
    elseif( str(1)=='u' )
        if( last==1 )
            Npoles = lastNpoles;
        else
            Nzeros = lastNzeros;
        end
    else
        break;
    end
    
    F = ones(Ny,Nx);
    f = ones(Nq,1);
    for izero=[1:Nzeros]
        V = complex( X-xzero(izero), Y-yzero(izero));
        F = F .* V;
        v = complex( xc-xzero(izero), yc-yzero(izero));
        f = f .* v;
    end
    for ipole=[1:Npoles]
        V = complex( X-xpole(ipole), Y-ypole(ipole));
        k=find( abs(V)>10 );
        if( ~isempty(k) )
            V(k)=10;
        end
        F = F ./ V;
        v = complex( xc-xpole(ipole), yc-ypole(ipole));
        k=find( abs(v)>10 );
        if( ~isempty(k) )
            v(k)=10;
        end
        f = f ./ v;
    end
    clf;
    subplot(2,1,1);
    set(gca,'LineWidth',2);
    hold on;
    axis xy;
    axis( [xmin, xmax, ymin, ymax] );
    imagesc([xmin,xmax],[ymin,ymax],abs(F));
    plot( xc, yc, 'w-', 'LineWidth', 2 );
    for ipole=[1:Npoles]
        if( ypole(ipole) < 0 )
            continue;
        end
        plot( xpole(ipole), ypole(ipole), 'w+', 'LineWidth', 2 );
    end
    for izero=[1:Nzeros]
        if( yzero(izero) < 0 )
            continue;
        end
        plot( xzero(izero), yzero(izero), 'wo', 'LineWidth', 2 );
    end
    subplot(2,1,2);
    set(gca,'LineWidth',2);
    hold on;
    axis([0, pi, 0, max(abs(f))]);
    plot( q, abs(f), 'k-', 'LineWidth', 2 );
    subplot(2,1,1);
end

fprintf('%d zeros\n', Npoles);
for izero=[1:Nzeros]
    fprintf('    (%f, %f)\n', xzero(izero), yzero(izero) );
end
fprintf('%d poles\n', Npoles);
for ipole=[1:Npoles]
    fprintf('    (%f, %f)\n', xpole(ipole), ypole(ipole) );
end




