clear all;

Fmax = 2.5;
NF = 101;
F = Fmax*[0:NF-1]'/(NF-1);


N1 = 48;
N2 = 46;
Fobs = 1.14;
p = fpdf(F, N1, N2);
Fmean = N2/(N2-1);
Fvar = 2*(N2^2)*(N1+N2-2)/(N1*((N2-2)^2)*(N2-4));
Fs = sqrt(Fvar);


figure(1);
clf;
set(gca,'LineWidth',2);
hold on;
pmax = max(p);
axis( [0, Fmax, 0, pmax] );
plot( F, p, 'k-', 'LineWidth', 2 );
plot( [Fobs, Fobs]', [0,0.05*pmax]', 'g-', 'LineWidth', 3 );

plot( [Fmean, Fmean]', [0,0.07*pmax]', 'r-', 'LineWidth', 3 );
plot( [Fmean-2*Fs, Fmean+2*Fs]', [0,0]', 'r-', 'LineWidth', 3 );

xlabel('F');
ylabel('p(F)');


