clear all;

Nt = 4;
N = 25;
d = random('unid',Nt,N,1);

h=zeros(4,1);
for i=[1:N]
    h(d(i))=h(d(i))+1;
end
h = h/N;

figure(1);
clf;
set(gca,'LineWidth',2);
hold on;
axis( [0, Nt+1, 0, 1 ] );
for i=[1:Nt]
    plot( [i, i]', [0, h(i)]', 'k-', 'LineWidth', 3 );
end
plot( [0, Nt+1]', [1/Nt, 1/Nt]', 'r:', 'LineWidth', 2 );
xlabel('d');
ylabel('counts');

Nr = 10000;
Nmax = N;
hc=zeros(Nmax+1,1);
target=1;
for ir=[1:Nr]
    dr = d(unidrnd(N,N,1));
    count=length(find(dr==target));
    if( (count>=0) && (count<=Nmax) )
        hc(count+1) = hc(count+1)+1;
    end
end
hc = hc/sum(hc);

figure(2);
clf;
set(gca,'LineWidth',2);
hold on;
axis( [0, Nmax, 0, max(hc) ] );
plot( [0:Nmax]', hc, 'k-', 'LineWidth', 3 );
xlabel('N');
ylabel('p(N)');

b = binopdf([0:Nmax]',N,1/Nt);
plot( [0:Nmax]', b, 'r-', 'LineWidth', 2 );


